/*    uiservercommon.h
 *
 * Common definitions for Nethack UI client and server
 *
 * Copyright 2004 Petteri Kangaslampi
 *
 * See license.txt for full copyright and license information.
*/

#ifndef __UISERVERCOMMON_H__
#define __UISERVERCOMMON_H__

#include <e32base.h>
#include <gdi.h>
#include <e32keys.h>

// Server name
_LIT(KUiServerName, "UiServer");

// Server version
const TUint KUiServerVersionMajor = 1;
const TUint KUiServerVersionMinor = 0;
const TUint KUiServerVersionBuild = 0;


// Request numbers
enum TUiServerRequest {
    EUiReqGetKey,
    EUiReqDrawText,
    EUiErrorMessage,
    EUiSetCursor
};


// Common message structures


// Draw text data structure
struct TUiDrawTextData {
    TInt iX;
    TInt iY;
    TRgb iFgColor;
    TRgb iBgColor;
    TInt iTextLength;
};
typedef TPckgBuf<TUiDrawTextData> TUiDrawTextBuf;


// Key press message
struct TUiKeyData {
    TKeyCode iKey;
    TUint32 iModifiers;
};
typedef TPckgBuf<TUiKeyData> TUiKeyBuf;


// Cursor message
struct TUiCursorData {
    TInt iX;
    TInt iY;
};
typedef TPckgBuf<TUiCursorData> TUiCursorBuf;



#endif
