/*
 * This file is the Epoc equivalent of pcunix.c etc.
 */
#include "hack.h"
#include <sys/stat.h>

# ifdef WANT_GETHDATE
static struct stat hbuf;
# endif

void
   gethdate(name)
   char *name;
{
# ifdef WANT_GETHDATE
/* old version - for people short of space */
//
// register char *np;
//      if(stat(name, &hbuf))
//	      error("Cannot get status of %s.",
//		      (np = rindex(name, '/')) ? np+1 : name);
//
// version using PATH from: seismo!gregc@ucsf-cgl.ARPA (Greg Couch) */

/*
 * The problem with   #include  <sys/param.h> is that this include file
 * does not exist on all systems, and moreover, that it sometimes includes
 * <sys/types.h> again, so that the compiler sees these typedefs twice.
 */
#define	 MAXPATHLEN      1024

   register char *np, *path;
char filename[MAXPATHLEN+1], *getenv();

if (index(name, '/') != (char *)0 || (path = getenv("PATH")) == (char *)0)
    path = "";

    for (;;) {
        if ((np = index(path, ':')) == (char *)0)
            np = path + strlen(path);       /* point to end str */
        if (np - path <= 1)		     /* %% */
            Strcpy(filename, name);
        else {
            (void) strncpy(filename, path, np - path);
            filename[np - path] = '/';
            Strcpy(filename + (np - path) + 1, name);
        }
        if (stat(filename, &hbuf) == 0)
            return;
        if (*np == '\0')
            path = "";
        path = np + 1;
    }
    error("Cannot get status of %s.", (np = rindex(name, '/')) ? np+1 : name);
# endif /* WANT_GETHDATE */
}


void regularize(s)
/*
 * normalize file name - we don't like .'s, /'s, spaces, and
 * lots of other things
 */
   register char *s;
{
    register char *lp;

    for (lp = s; *lp; lp++)
        if (*lp <= ' ' || *lp == '"' || (*lp >= '*' && *lp <= ',') ||
            *lp == '.' || *lp == '/' || (*lp >= ':' && *lp <= '?') ||
# ifdef OS2
            *lp == '&' || *lp == '(' || *lp == ')' ||
# endif
            *lp == '|' || *lp >= 127 || (*lp >= '[' && *lp <= ']'))
            *lp = '_';
}
