/*    nethackappui.h
 *
 * Nethack UI Application UI class
 *
 * Copyright 2002-2004 Petteri Kangaslampi
 *
 * See license.txt for full copyright and license information.
*/

#ifndef __NETHACKAPPUI_H__
#define __NETHACKAPPUI_H__

#include <eikappui.h>
#include "uiserver.h"

class CNethackAppView;
class CUiServer;
class CS2Font;


/**
 * Nethack UI Application UI class.
 */
class CNethackAppUi: public CEikAppUi, public MUiServerObserver {
    
public:
    void ConstructL();
    CNethackAppUi();
    ~CNethackAppUi();

    void HandleCommandL(TInt aCommand);
    
    void ShowMemoryStatusL();

    void DrawWelcomeMessage();

    void MusoSessionStarted();
    void MusoSessionTerminated();
    void MusoErrorMessage(const TDesC &aMessage);
    void MusoFatalError(TInt aError);    
    
    
private:
    CNethackAppView *iAppView;
    TInt iTermWidth, iTermHeight;
    TBool iLargeFont;
    TBool iFullScreen;
    CUiServer *iServer;
    TBool iEngineRunning;
    TFileName iAppPath;
    CS2Font *iFont;
    TBool iExiting;
    TBool iGameRunning;
};


#endif
