/*    nethackappview.h
 *
 * Nethack UI View class
 *
 * Copyright 2002,2004 Petteri Kangaslampi
 *
 * See license.txt for full copyright and license information.
*/

#ifndef __NETHACKAPPVIEW_H__
#define __NETHACKAPPVIEW_H__

#include <coecntrl.h>
#include "terminalcontrol.h"


class CNethackAppUi;
class CS2Font;


/**
 * Nethack UI application view class. Owns the terminal control.
 */
class CNethackAppView : public CCoeControl {
    
public:
    CNethackAppView(CNethackAppUi *aAppUi, CS2Font *aFont);
    ~CNethackAppView();
    void ConstructL(const TRect& aRect);

    virtual TInt CountComponentControls() const;
    virtual CCoeControl *ComponentControl(TInt aIndex) const;
    virtual TKeyResponse OfferKeyEventL(const TKeyEvent &aKeyEvent,
                                        TEventCode aType);

    CTerminalControl *Terminal();

    void SetFullScreenL(TBool aFullScreen);

private:
    void Draw(const TRect &aRect) const;
    virtual void SizeChanged();

    void ResizeTerminal();

    MTerminalObserver *iTerminalObserver;
    CTerminalControl *iTerminal;
    TRect iTermRect;
    TBool iLargeFont;
    TBool iFullScreen;
    TBool iChrDown;
    CNethackAppUi *iAppUi;
    CS2Font *iFont;
};

#endif
